#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include <math.h>    

#include "global.h"
#include "properties_xfig.h"

/* 
011001 proberties_xfig.h included , deepness of connections modified 
*/


/*----------------------read_connections------------------------*/
int read_connections(char ***line_word_array,int i_line,int current_unit,
                 int ***input_box,int ***output_box,int un_max_xfig,
                 int **input_unit_xfig,int **input_out_nr_xfig
                ,int input_max,int **connection,struct substitute_struct *subs)
{
int a=0; /*--------------------ANALYSE a=1-------------------------*/
int check=-1;
int x1,y1,x2,y2,x3,y3; /* begin, end-point */
int i_word,i_line_offset,i_unit,i_no;
char *rest;
int output_unit=0,output_no=0;
static int i_connection=0; /* index for connections */

/* search in line i+1...i+n till 9999 for x,y-coordinates of end_point*/
/* no 9999 in xfig 3.1 !!!!! */

x1=(int) strtod( (char*) line_word_array[i_line+1][1],&rest);
y1=(int) strtod( (char*) line_word_array[i_line+1][2],&rest);

i_word=1;
i_line_offset=1;
/*string-end-label attention: this has changed in xfig 3.1 */
if (a) printf("i_line:%d i_line_offset:%d\n",i_line,i_line_offset);
while ( 
         (i_line_offset <= 5)
      && (strstr (line_word_array[i_line+i_line_offset][0],"\t") != NULL)
      )
  {
  x2=(int) strtod( line_word_array[i_line+i_line_offset][i_word  ],&rest);
  y2=(int) strtod( line_word_array[i_line+i_line_offset][i_word+1],&rest);

  if (a) printf("-------------------------x2,y2:[%d][%d]\n",x2,y2);

  /* next word */
  if (  (i_word>=WORD_MAX-2)
      ||(line_word_array[i_line+i_line_offset][i_word+2][0]=='\0') 
     )
     {i_line_offset++;i_word=1;}
  else i_word+=2;
  if (a) printf("i_line:%d i_line_offset:%d i_word:%d\n"
               ,i_line,i_line_offset,i_word);
  } /* while current line command */
if (a) printf("connection found from [%d][%d] to [%d][%d] \n"
       ,x1,y1,x2,y2);

/* set depth of lines */
/* if ( (int) strtod( (char*) line_word_array[i_line+0][PEN_COLOR_POS],&rest)!=BLACK) 
*/
if (1) { /* set properties and layerts ... of line connections */
 int color=(int) strtod( (char*) line_word_array[i_line+0][PEN_COLOR_POS],&rest);
 int line_style=(int) strtod( (char*) line_word_array[i_line+0][LINE_STYLE_POS],&rest);
 int line_width=(int) strtod( (char*) line_word_array[i_line+0][WIDTH_POS_POLYGON],&rest);
 int set_depth=0;
 
 /* predefined lyers for connections */
 /*controller connects */
 if ( (color==BLACK) && (line_style==DASHED) && (line_width==2) ) set_depth=CONNECTION_DEEPNESS_03;
 /* printer */
 if ( (color==WHITE) && (line_style==DASHED) && (line_width==1) ) set_depth=CONNECTION_DEEPNESS_06;
 /* weather */
 if ( ( (color!=BLACK) && (color!=WHITE) )      
     && (line_style==SOLID ) && (line_width==2) ) set_depth=CONNECTION_DEEPNESS_04;
 /* gnuplotter */
 if ( ( (color!=BLACK) && (color!=WHITE) )      
     && (line_style==DASHED ) && (line_width==3) ) set_depth=CONNECTION_DEEPNESS_05;
 /* hydraulic */
 if ( ( (color!=BLACK) && (color!=WHITE) )      
     && (line_style==SOLID ) && (line_width==3) ) set_depth=CONNECTION_DEEPNESS_01;
 /* hydraulic , closed cycles */
 if ( ( (color!=BLACK) && (color!=WHITE) )      
     && (line_style==DASHED ) && (line_width==2) ) set_depth=CONNECTION_DEEPNESS_02;

 if (set_depth==0) {
  static int once=1;
  set_depth=CONNECTION_DEEPNESS_00; /* set layer 999 for unknown line styles ! */
  if (once) printf("unknown connection properties, use this style conventions:\n"
         "controller: BLACK DASHED line_width 2 layer:%d\n"
         "printer: WHITE DASHED line_width 1 layer:%d\n"
         "weather: COLOR SOLID line_width 2 layer:%d\n"
         "gnuplotter: COLOR DASHED line_width 3 layer:%d\n"
         "hydraulic: COLOR SOLID line_width 3 layer:%d\n"
         "hydraulic , closed cycles: COLOR DASHED line_width 2 layer:%d\n \n "
         " ... connection moving to layer 999\n\n",
         CONNECTION_DEEPNESS_03,CONNECTION_DEEPNESS_06,CONNECTION_DEEPNESS_04,
         CONNECTION_DEEPNESS_05,CONNECTION_DEEPNESS_01,CONNECTION_DEEPNESS_02);
  once=0;/* print just one time  */
 }
 substitute_property_in_xfig_object(line_word_array,i_line,subs,DEEPNESS_POS_POLYGON,set_depth);
 
#if 0
 if ( (int) strtod( (char*) line_word_array[i_line+0][DEEPNESS_POS_POLYGON]
            ,&rest) !=CONNECTION_DEEPNESS) {
   printf("read_connections: line:%d deepness:%s modified to:%d pos:%d\n",
   i_line,line_word_array[i_line+0][DEEPNESS_POS_POLYGON],CONNECTION_DEEPNESS,
   subs->point);
   substitute_property_in_xfig_object(line_word_array,i_line,
                subs,DEEPNESS_POS_POLYGON,CONNECTION_DEEPNESS);
 } /* check CONNECTION_DEEPNESS */
#endif
} /*  set properties */


if (a) fflush(stdout);
if (    (x1==x2)
     && (y1==y2)
   )
   {
     printf( "its a box or a point symbol from [%.1f][%.1f] to [%.1f][%.1f] \n"
             ,(double) x1/450,(double) y1/450,(double) x2/450,(double) y2/450);
     return (-1); /* its a box symbol */
   }
   

/*-----------------------now compare with boxes ---------------*/
/* first searching output-no---------------*/
for (i_unit=1;i_unit<=un_max_xfig;i_unit++)
  {
  if (0) printf("read_connections: i_unit:%d \n",i_unit);
  for (i_no=1;i_no<=OUT_MAX;i_no++)
    {

    if (   (x1 >= output_box[i_unit][i_no][1])
        && (x1 <= output_box[i_unit][i_no][3])
        && (y1 >= output_box[i_unit][i_no][2])
        && (y1 <= output_box[i_unit][i_no][4])
       )
       {
       if (a) printf(
                     "output_box[%d][%d] found:[x1:%d][y1:%d][x2:%d][y2:%d]\n"
                     ,i_unit,i_no
                     ,output_box[i_unit][i_no][1]
                     ,output_box[i_unit][i_no][2]
                     ,output_box[i_unit][i_no][3]
                     ,output_box[i_unit][i_no][4]);

       output_unit=i_unit;
       output_no  =i_no;
       check=1;
       break;
       }

    if (   (x2 >= output_box[i_unit][i_no][1])
        && (x2 <= output_box[i_unit][i_no][3])
        && (y2 >= output_box[i_unit][i_no][2])
        && (y2 <= output_box[i_unit][i_no][4])
       )
       {
       if (a) printf("output_box found change x1..x2 \n"
                     "output_box[%d][%d]:[x1:%d][y1:%d][x2:%d][y2:%d]\n"
                     ,i_unit,i_no
                     ,output_box[i_unit][i_no][1]
                     ,output_box[i_unit][i_no][2]
                     ,output_box[i_unit][i_no][3]
                     ,output_box[i_unit][i_no][4]);

       output_unit=i_unit;
       output_no  =i_no;
       check=1;
       x3=x1;          /* change coordinates from .. to  */
       y3=y1;
       x1=x2;
       y1=y2;
       x2=x3;
       y2=y3;
       break;
       }

    }
  }
if (check==-1)
  {
  printf("no outputbox for a line-symbol found: !! (no double out_no's!)\n"
         "current line from [%.1f][%.1f] to [%.1f][%.1f] cm \n"
         ,(double) x1/450, (double) y1/450, (double) x2/450, (double) y2/450);
  for (i_unit=1;i_unit<=un_max_xfig;i_unit++)
  for (i_no=1;i_no<=input_max;i_no++)
  if (output_box[i_unit][i_no][1]!=0)
  if (a) printf("output_box[%d][%d]:[x1:%d][y1:%d][x2:%d][y2:%d]\n"
          ,i_unit,i_no
          ,output_box[i_unit][i_no][1]
          ,output_box[i_unit][i_no][2]
          ,output_box[i_unit][i_no][3]
          ,output_box[i_unit][i_no][4]);

  return (-1);
  }
check=-1;

/*--------- now search the input-box for this output */
for (i_unit=1;i_unit<=un_max_xfig;i_unit++)
  {
  for (i_no=1;i_no<=input_max;i_no++)
    {
    if ( (a) && (input_box[i_unit][i_no][1]!=0) )
    printf("unit:%d input_box:%d [x1:%d][y1:%d][x2:%d][y2:%d]\n"
      ,i_unit,i_no,input_box[i_unit][i_no][1]
                  ,input_box[i_unit][i_no][2]
                  ,input_box[i_unit][i_no][3]
                  ,input_box[i_unit][i_no][4]);

    if (   (x2 >= input_box[i_unit][i_no][1])
        && (x2 <= input_box[i_unit][i_no][3])
        && (y2 >= input_box[i_unit][i_no][2])
        && (y2 <= input_box[i_unit][i_no][4])
       )
       {
       if (a) printf(
                     "inp_box[%d][%d] found:[x1:%d][y1:%d][x2:%d][y2:%d]\n"
                     ,i_unit,i_no
                     ,input_box[i_unit][i_no][1]
                     ,input_box[i_unit][i_no][2]
                     ,input_box[i_unit][i_no][3]
                     ,input_box[i_unit][i_no][4]);
       
       if (0) printf("connection line:%d offs:%d [%d][%d] to [%d][%d] \n"
                     ,i_line,i_line_offset,x1,y1,x2,y2);
       connection[i_connection][1]=x1;
       connection[i_connection][2]=y1;
       connection[i_connection][3]=x2;
       connection[i_connection][4]=y2;
       connection[i_connection][5]=i_line;
       connection[i_connection][6]=i_line_offset;
       i_connection++;
       if (i_connection>=CONNECTION_MAX) {
         printf("i_connection:%d>CONNECTION_MAX:%d, exiting\n"
                ,i_connection,CONNECTION_MAX); exit (-1);
       }
       connection[i_connection][1]=END;

       check=1;
       input_unit_xfig  [i_unit][i_no]=output_unit;
       input_out_nr_xfig[i_unit][i_no]=output_no;
       break;
       }
    } /* input_number i_no */
  if (a) printf("\n");
  } /* i_unit */
if (check==-1) {
  printf("unit:%d,out_number:%d output connection not linked !! \n"
                       "(currupt input-box, multiple numbering of "
                        "adjacent input-box, etc ...)\n"
		       ,output_unit,output_no);
  printf("line:%d [x1:%d][y1:%d][x2:%d][y2:%d]\n",i_line,x1,y1,x2,y2);
  /* exit (-1); */
  }


return (check);
}
/*-------------------------------------------------------------------*/

