# awk script to plot load_profile
# awk -f ./etc/ShowLoadProfile.awk <load.dat >loadWW.dat
#
#
BEGIN { n=0
        timedec=0
	timedec_old=0
	mp=0
	mp_old=0
	P_WW=0
	P_WW_old=0
	Q_WW=0
    Q_next_hour=0
    step_counter=0
    printf("#TIME[hhmmss] mp[kg/h] T_WW[C] P_WW[W] Q_WW[kWh]\n#\n");
      }
{
n+=1
if (n==1) { 
           for (i=1;i<=NF;i++) { col_name[i]=$i
#	                         printf("%s  ",col_name[i])
                               }
#           printf("\n")			       
	  }
if (n>2) {
       if (length($1)==6) # day profile
        {
        time_hour=substr($1,1,2) ;
        time_min =substr($1,3,2) ;
        time_sec =substr($1,5,2) ;
        }
       if (length($1)==7)       # week profile
        {
        time_hour=substr($1,1,3) ;
        time_min =substr($1,4,2) ;
        time_sec =substr($1,6,2) ;
        }


     timedec=time_hour+time_min/60+time_sec/3600
     timedec_day=timedec-24*int(timedec/24);
	 mp=$2
	 TWW=$3
     Brenner=$4
	 
	 P_WW=mp*4.19*(TWW-10)/3600                # kW 
     if (timedec<timedec_old) Q_WW_day=0;
	 if (mp_old>0) { Q_WW+=P_WW_old*(timedec-timedec_old) # kWh
                     Q_next_hour+=P_WW_old*(timedec-timedec_old)
                     Q_WW_day+=P_WW_old*(timedec-timedec_old) # kWh
                     step_counter+=1
                   }
	 P_WW_old=P_WW
	 timedec_old=timedec
	 mp_old=mp
	 
	 printf("%s ",$1) 
	 printf("%f ",mp)
	 printf("%f ",TWW)
	 printf("%f ",P_WW)
#	 printf("%f ",Q_WW) 
 	 printf("%f ",Q_WW_day) 
 	 printf("\n") 
     timedec_day_old=timedec_day;
#
}
}
