#!/bin/bash
# awk -f etc/get_lauf_min_and_max.awk dat/system8_3/pump_histogram.dat
#                                                                                        
BEGIN {
  a=0;
 min_lauf=1e12;
 min_found=0;
 max_lauf=-1e12;
 max=-1e12; # hufigkeitsmaximum
}
{ # MAIN check paramter of INFO unit
work_time    =$1
NumberOfTimes=$2
sum_runtime  =$3
sum_switches =$4
if ( (NumberOfTimes>max) && ($0~!"#") ) max=NumberOfTimes;
if ((NumberOfTimes<min_lauf) && (NumberOfTimes>0) && (!min_found) ) {
 min_lauf=work_time
 min_found=1;
}
if ((NumberOfTimes>0) && ($0~!"#") ) {
 max_lauf=work_time
}
}
END {
printf("min_lauf:%d\n",min_lauf);
printf("max_lauf:%d\n",max_lauf);
printf("max:%d\n",max);

}

#work_time[min] NumberOfTimes[1] sum_runtime[h] sum_switches[1]
#0 0 0.00 0
#1 0 0.00 0
#2 0 0.00 0
