# jahresdauerlinie2.awk
# wc sim_out2.dat
# awk -f etc/jahresdauerlinie2.awk -v col=19 -v lines_in_file=8763 sim_out1.dat sim_out1.dat > jahresdauerlinie.dat

BEGIN { 
a=0;
column = col
max_old = -1e99
min_old =  1e99
FileNr=1; #Flag 1:load.dat 2:.xfig
        wert           = 0
        intervall_step = 100
        scale[s]       = 0
        count_line     = 0
}
{ # MAIN
if (FileNr==1) { # read headline of load.dat
 if (!match($1,"#") ) {
  if ( $column > max_old ) max_old = $column
  if ( $column < min_old ) min_old = $column
 }
if (a) printf("file1:%d:%s\n",FNR,$0);
 if (NR==lines_in_file) { 
  FileNr=2; #take 2nd input-file of arg
  min=min_old
  max=max_old
  nextfile
 }
 } #end file 1
else { # file 2
 intervall      = ( max - min ) / intervall_step
 if (a) printf("min:%.2f max:%.2f column:%d  intervall:%.2f\n",min,max,column,intervall);
 # in jeder datenzeile raw-data wert vergleichen 
 s = 1
 
 if (!match($1,"#") ) {
  for( wert = min; wert <= max; wert = wert + intervall ) {
    if ( $column >= wert ) { 
      scale[s] = scale[s] + 1
      s ++ 
      }
    else next
  }
 }
 #
 if (a) printf("file2:%s\n",$0);

}
#  column,max_old,min_old
} # MAIN
END {
 if (a) printf("end2:%s\n",$0);
 for( s = 1; s <= intervall_step; s ++)
         printf( "%d %s\n", scale[s], s * intervall + min )
}

