# make monthly energy from daily energy 
# call: ./etc/month_energy.awk <./sim_out0.dat 
awk '
  BEGIN {
	  n=0
      HourOfYear=0
      Month=01
      Month_old=01
      days=31
        }
  {
  n+=1
  HourOfYear+=24  # if the data base is daily !!!
  #-----set Month -------------------------------------------------#         
  if   ( HourOfYear<=743 )                           { Month=01; FirstDay=01; days=31; }
  if ( ( HourOfYear>743 )  && ( HourOfYear<=1415 ) ) { Month=02; FirstDay=32; days=28; }
  if ( ( HourOfYear>1415 ) && ( HourOfYear<=2159 ) ) { Month=03; FirstDay=60; days=31; }
  if ( ( HourOfYear>2159 ) && ( HourOfYear<=2879 ) ) { Month=04; FirstDay=91; days=30;  }
  if ( ( HourOfYear>2879 ) && ( HourOfYear<=3623 ) ) { Month=05; FirstDay=121; days=31; }
  if ( ( HourOfYear>3623 ) && ( HourOfYear<=4343 ) ) { Month=06; FirstDay=152; days=30; }
  if ( ( HourOfYear>4343 ) && ( HourOfYear<=5087 ) ) { Month=07; FirstDay=182; days=31; }
  if ( ( HourOfYear>5087 ) && ( HourOfYear<=5831 ) ) { Month=08; FirstDay=213; days=31; }
  if ( ( HourOfYear>5831 ) && ( HourOfYear<=6551 ) ) { Month=09; FirstDay=244; days=30; }
  if ( ( HourOfYear>6551 ) && ( HourOfYear<=7295 ) ) { Month=10; FirstDay=274; days=31; }
  if ( ( HourOfYear>7295 ) && ( HourOfYear<=8015 ) ) { Month=11; FirstDay=305; days=30; }
  if ( ( HourOfYear>8015 ) && ( HourOfYear<=8759 ) ) { Month=12; FirstDay=335; days=31; }
  
  
  if (n==1) nf=NF
  for(i=1;i<=NF;i+=1) sum_month[i]=sum_month[i]+$(i+1)
  for(i=1;i<=NF;i+=1) sum_year[i]=sum_year[i]+$(i+1)
  if ( (Month!=Month_old) || (HourOfYear>8750) ) {
    printf("%d ",Month_old)
    for(i=1;i<=(nf-1);i+=1) printf("%.3f ",sum_month[i]/days_old);
    for(i=1;i<=NF;i+=1) sum_month[i]=0; #reset 
    printf("\n");
    }
  Month_old=Month
  days_old=days
  }
END {
#    printf("13 ")
#    for(i=1;i<=(nf-1);i+=1) printf("%.3f ",sum_year[i]/365);
#    printf("\n");
    }
'

