# update_outboxes_with_load_profil_header.awk
# awk -f update_outboxes_with_load_profil_header.awk load.dat $HOME/.xfig > $HOME/.xfig_new
BEGIN {
a=0; #debug mode
ShiftOut678_flag=1; # use this for old weather,load types
OUT_MAX0=20;

out[1]="label1[Ws]" # labels are read from headline file1
out[2]="label2"
out[3]="label3"
out[4]="label4"
out[5]="label5"
out[6]="sys_gain[Ws]"
out[7]="sys_loss[Ws]"
out[8]="sys_cap[Ws]"

line_style_4_before =0
line_style_3_before =0
line_style_2_before =0
line_style_1_before =0
line_style_current  =0

compound_begin="6"
polygon=2
text=4
i_out=0; # number of output

i=0;
FileNr=1; #Flag 1:load.dat 2:.xfig
} # end begin
#
{ # check comment in box compound
if (FileNr==1) { # read headline of load.dat
 if (a) printf("--------------------load.dat:%s\n",$0);
 for (i=1;i<=NF-1;i++) {
   if (ShiftOut678_flag && (i>=6) ) out[i+3]=$(i+1); 
   else                             out[i  ]=$(i+1);
   }
 if (ShiftOut678_flag && (NF-1>=6) ) OUT_MAX=NF-1+3;
 else                                OUT_MAX=NF-1;
 # get out_label and unit
 for (i=1;i<=OUT_MAX0;i++) { # take more than eff OUT_MAX for additional boxes
  i_max=length(out[i]); # get size
  if ( i_max>0 ) { # outlabel existant
   #printf("%s\n",out[i]);
    if ( match( out[i],"]" ) )  { #scan unit
      #printf("i_max:%d\n",i_max);
      for (i1=1;i1<=i_max;i1++) {
        # printf("%d:%c,",i1,substr(out[i],i1,1));
        if (substr(out[i],i1,1)=="[") unit[i]=substr(out[i],i1);
        }
      out[i]=substr(out[i],1,length(out[i])-length(unit[i])); 
      #if (a) printf("bracketfound unit:%s out:%s\n",unit[i],out[i]);
      } # unit is existant
    else unit[i]=sprintf("[1]");
    } #outlabel existant
  else { # no out label
   out[i] =sprintf("out%d",i);
   unit[i]=sprintf("[1]");
   }
   ######## print all labels and units [] ###########
  if (a) printf("%d out:%s unit:%s\n",i,out[i],unit[i]);
  } #i_out
 FileNr=2; #take 2nd input-file of arg
 nextfile
 } # end of reading file1 load.dat
#-------------------------------------------end of reading file1---------------
# printf("file2:%s\n",$0);
# exit ;
# -------------------------------------------search boxes
i++
style_current=$1
if (a) printf("line:%d %s   search:6:%s,2:%s,4:%s \n",i,$1 \
       ,style_4_before,style_3_before,style_1_before);
if (  (style_current==text) \
    &&(style_4_before==compound_begin) \
    &&(style_3_before==polygon) \
    &&(style_1_before==text) \
   ) {
   i_out++; # number of output
   for (i1=1;i1<=13;i1++) printf("%s ",$i1);
   if (substr($14,1,3)=="XxX")  { # substitude label in outbox
     if (out[i_out]!="") printf("%s \\001\n",out[1*StoredOutNr]);
     else                printf("out%d \\001\n",(1*StoredOutNr)  );
     }
   }
else { # no line with out-label , cheching for OUTxx pattern
 #4 0 7 99 0 0 11 0.0000 12 135 735 5040 11910 OUT1: [1] . \001
 if (match($14,"OUT")) { # info out-line found
   OutLineString=$0 # store the first appearance of an OUT line
   i1=0; do i1++; while ( (substr($14,i1,1)!=":") && (i1<=length($14) ) ) ;
   OutNr=1*substr($14,4,i1-4) ;
   if (a) printf("#######################out:%s OutNr:%d\n",$14,OutNr);
   #get current comment
   i1=0; do i1++; while ( (substr($0,i1,1)!="T") && (i1<=length($0) ) ) ;
   i2=length($0); do i2--; while ( (substr($0,i2,1)!="]") && (i2>1) )
   printf("%s%d: %s '%s' %s \n",substr($0,1,i1),OutNr,unit[OutNr],\
          out[OutNr],substr($0,i2+1,length($0)) );
   }
 else { # no OUT line
   if ( (length(OutLineString)>0) && (OutNr<OUT_MAX) ) { #add OUT line
     i1=0; do { i1++;} 
           while ( (substr(OutLineString,i1,1)!="T") && (i1<=length(OutLineString) ) ) ;
     string=substr(OutLineString,1,i1);
     for (i1=OutNr+1;i1<=OUT_MAX;i1++) {
       if (a) printf("++++++++++++Add:%s%d: %s comment%d \\001\n",string,i1,unit[i1],i1);
       printf("%s%d: %s '%s' comment%d \\001\n",string,i1,unit[i1],out[i1],i1);
       }
     OutNr=OUT_MAX;
     }
   printf("%s\n",$0);
   } # no  OUT line
 } # no out_box line
if (style_current==text) { # try searching current out_nr
  i1=0; 
  do { # search \ ind this word 14
    i1++; } while ( (substr($14,i1,1)!="\\") && (i1<5) ) ;
  StoredOutNr=substr($14,1,i1) ;
  if (a) printf("#######StoredOutNr:%d i1:%d out:%s \n",\
       StoredOutNr,i1,out[1*StoredOutNr] );
  }
# shift entries
style_4_before =sprintf("%s",style_3_before);
style_3_before =sprintf("%s",style_2_before);
style_2_before =sprintf("%s",style_1_before);
style_1_before =sprintf("%s",style_current);
}

