/*
 common.h
*/


#define X 0
#define Y 1
#define END -1
#define CONCL -2
#define SET_IMAX 20 /* max number of points of SET polygon_line */
#define SET_IOUT_MAX 50 /* more than IMAX !!, caused by ifthen & max */
#define MAX_TERM 10 /* max Zahl v. Termen pro Variable */
#define RULES_MAX 80

#define INPUTMAX 10   /*  max number of inputs +1   */

/* plot SET to gnuplot-script --------------------------------*/
int plot_set(int SET_number,int term_max,
             double SET[INPUTMAX+1][MAX_TERM][SET_IMAX][2],
             char name[INPUTMAX] [MAX_TERM][10] );

/* plot OUT_SET to gnuplot-script ---------------------------*/
int plot_OUT_SET(int rule_max,
                  double OUT_SET[RULES_MAX][SET_IMAX+30][2]
                 ,double FuzzyOUT          [SET_IMAX+30][2] 
                 ,double out );


double AND(double a, double b);

int MAX( double OUT_SET[RULES_MAX][SET_IMAX+30][2]
        ,double FuzzyOUT          [SET_IMAX+30][2]
        ,int rule_max);

double center_of_gravity(double FuzzyOUT[SET_IMAX+30][2] );

double get_sharp_value(double x, double FuzzyOUT[SET_IMAX+30][2] );
     /* return FuzzyOUT - y value for the x value */

double EQU(double SET[INPUTMAX+1][MAX_TERM][SET_IMAX][2], double in[INPUTMAX], 
           int input_number,int ling_term);


int IF_THEN(double SET[INPUTMAX+1][MAX_TERM][SET_IMAX][2],  \
            double OUT_SET[RULES_MAX][SET_IMAX+30][2],int OUT \
            , int rule,int ling_term,double mue);

int check_INPUTs(double SET[INPUTMAX+1][MAX_TERM][SET_IMAX][2],
                 double XMIN[INPUTMAX],double XMAX[INPUTMAX],
                 int TERM_MAX[INPUTMAX],int test, int OUT);


