#include "gl2ps.h"
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>

#include <GL/glut.h>
#include <GL/gl.h>

#include "gl_global.h"
#include "gl_var.h"


void display2 (void){
  glutSetWindow (mainWindowID2);
  glClearColor (0.79, 0.89, 0.69, 0.0);
  glClear (GL_COLOR_BUFFER_BIT );

   glColor3fv(color[1]);
   glBegin (GL_LINE_STRIP);
   glVertex2f (0.0,1.0);
   glVertex2f (1.0,1.0);
   glVertex2f (1.0,0.0);
   glVertex2f (0.0,0.0);
   glVertex2f (0.0,1.0);
  glEnd ();
glCallList(4);
glCallList(5);
         glPushMatrix();
  glTranslatef(pump_mp/5.0e3,pump_dp/maxdp,0.0);
         glCallList(3);
         glPopMatrix();

     glColor3fv(color[1]);

/*
   glBegin (GL_LINE_STRIP);
   glVertex2f (pump_mp/1.0e4,pump_dp/5.0e4);
   glVertex2f (0.0,0.0);
  glEnd ();
*/

  glutSwapBuffers();
  glFlush();
}
/*---------------------------------------------*/
void
display (void)   /*hier wird gemalt */
{
  FILE *fopen(),*fp;
  int state;
  int buffsize;
  static char label[100];
  float xtmp;
  int i,r,s;
  float x,y;
  float dx,dy;
  float f[3];
  static float data[30][50];
  double decaderoundup();
  double zo,zu;
  int mant;

 glutSetWindow (mainWindowID);
 if (0) printf("in display %d  \n",mainWindowID);
 if (d3flag==2) {
 /*-----------------ps_out----------------------*/
if (ps_out) {
  fp = fopen("Online.ps", "w");
  buffsize = 0;
  state = GL2PS_OVERFLOW;
   buffsize += 1024*1024;
   gl2psBeginPage ( "OnlinePlotter", "ColSim",
                     GL2PS_BSP_SORT,
                     GL2PS_SIMPLE_LINE_OFFSET | GL2PS_SILENT,
                     GL_RGBA, 0, NULL, buffsize, fp );
  gl2psLineWidth( 3.5 );



   }
/*-----------------ps_out----------------------*/
 
 

  glClearColor (0.99, 0.99, 0.99, 0.0);
  glClear (GL_COLOR_BUFFER_BIT );
  glCallList(5);  
  glCallList(4);

  glColor3fv(color[1]);
   drawtext("(c)Max Mertins  2001",12,0.9,-1.15,0);
   drawtext("time",12,0.02,-1.15,0);  
  glColor3f (0.0F, 0.0F, 0.0F);
   drawtext("ColSim OnlinePlotter ",18,-.5,1.1,0);
  if (fence==1) {
  glLineWidth (1);
  glColor3f (.0F, .0F, 1.0F);

  glBegin (GL_LINE_STRIP);
   ox1d=ox1+xl/(1.0*W)*(ox2-ox1);
   oy1d=(oy2+(yo/H)*(oy1-oy2));
   ox2d=ox1+xmov/(1.0*W)*(ox2-ox1);
   oy2d=(oy2+(ymov/H)*(oy1-oy2));
   if (0) printf("y2=%5.3f ymov %5.3f\n",oy2d,ymov);

   glVertex2f (ox1d,oy1d);
   glVertex2f (ox2d,oy1d);
   glVertex2f (ox2d,oy2d);
   glVertex2f (ox1d,oy2d);
   glVertex2f (ox1d,oy1d);
  glEnd ();
  if (0) printf("xo %6.4f yo %5.4f\n",xl/W,yo/H);

             }
  else if (fence==2) {
            printf("fence==2\n");
            ox1=ox1d;ox2=ox2d;
            oy1=oy2d;oy2=oy1d;
           fence=0;
           zoom_mode=1;
           reshape(W,H);
                     }


 glCallList(2);
 if (ps_out) init_koord_text(); 
 /* Draw Plots */
  for (r=0;r<ndata;r++) {
    glColor3fv (color[r+1]);
    glLineWidth (2.0);
    glBegin (GL_LINE_STRIP);
    for (i=1;i<nN;i++) {
        x=(float) (2*i-((float) nN))/((float) nN);
        y=(shared_data[r][i]);
        glVertex2f (x,y);
                      }
   glEnd ();
   }
    for (r=3;r<3+ndata2;r++) {
    /*printf("OGLOGL %.4e\n",shared_data[r][nN-1]);*/
    glColor3fv (color[r+1]);
    glLineWidth (2.0);
    glBegin (GL_LINE_STRIP);
    for (i=1;i<nN;i++) {
        x=(float) (2*i-((float) nN))/((float) nN);
        y=(shared_data[r][i]);
        glVertex2f (x,y);
                      }
   glEnd ();
   }
/* time */
 glLineWidth (.5);
  glColor3f (.0F, .0F, .0F); 
   glEnable(GL_LINE_STIPPLE);
  glLineStipple(5, 0xAAAA); 
 glBegin(GL_LINES);
 glVertex2f (1.0-input[8]/(43200.0),1.0);
 glVertex2f (1.0-input[8]/(43200.0),-1.0);
 glEnd();
 glDisable(GL_LINE_STIPPLE);
 }

/*if zoomed*/


if (zoom_mode==1) {
           dx=fabs(ox2d-ox1d)/10.0;
           dy=fabs(oy2d-oy1d)/10.0;
zo=(parameter[4]-parameter[3])*(1.0+oy1d - 2*dy)*0.5+parameter[3];
zu=(parameter[4]-parameter[3])*(1+oy2d + dy)*.5+parameter[3];

if (0) printf("decaderoundup(oben=%e) %e %d\n",zo,decaderoundup(zo*.9,&mant),mant);
         sprintf (label, "%7.3e",zo );
         drawtext(label,12,ox1d + dx/4.0,oy1d -2*dy, 0);
         sprintf (label, "%7.3e",zu);
         drawtext(label,12,ox1d + dx/4.0,oy2d +dy, 0);
           glBegin (GL_LINE_STRIP);
                glVertex2f (ox1d + dx,oy1d-2*dy);
                glVertex2f (ox2d -dx ,oy1d-2*dy);
                glVertex2f (ox2d -dx,oy2d+dy);
                glVertex2f (ox1d +dx,oy2d+dy);
                glVertex2f (ox1d +dx,oy1d-2*dy);
               glEnd ();



                  }
/*if zoomed end*/


 /*-----------------ps_out----------------------*/
if (ps_out)
 {
 state = gl2psEndPage();
 fclose(fp);
 ps_out=0;
 }
/*-----------------ps_out----------------------*/
 
 /* Draw potential Function */
  glutSwapBuffers ();
   glFlush ();
};

void
subDisplay (){
char label[100];
int i;
  glutSetWindow (subWindowID);
  glClearColor (0.25, 0.25, 0.25, 0.0);
  glClear (GL_COLOR_BUFFER_BIT);

  glColor3f (0.0F, 1.0F, 0.0F);
  glBegin (GL_LINE_LOOP);
  glVertex2f (0.0F, 0.0F);
  glVertex2f (0.0F, 0.99F);
  glVertex2f (0.999F, 0.99F);
  glVertex2f (0.999F, 0.0F);
  glEnd ();
  glColor3f (1.0F, 1.0F, 1.0F);
  sprintf (label, "tsim : %6.1f sec ",tsim);
  if (1) drawtext(label,12,0.015,.7,0);
if (1) { 
for (i=0;i<ndata;i++) {
  glColor3fv (color[i+1]);
  sprintf (label, " %d: %7.3e ",i+1,input[10+i]);
  if (1) drawtext(label,12,0.1+((i)/2)*.15,.4-(i%2)*.3,0);
  }
for (i=0;i<ndata2;i++) {
  glColor3fv (color[i+1+ndata]);
  sprintf (label, " %d: %7.3e ",i+1+ndata,input[10+i+ndata]);
  if (1) drawtext(label,12,0.6+((i)/2)*.15,.4-(i%2)*.3,0);
  }
}

  
 


 
  

glutSwapBuffers ();
}

void display3 (void){
  glutSetWindow (mainWindowID3);
  glClearColor (0.79, 0.89, 0.69, 0.0);
  glClear (GL_COLOR_BUFFER_BIT );



   glBegin (GL_LINE_STRIP);
    glVertex2f (input[23],input[24]);
    glVertex2f (input[25],input[26]);
   glEnd ();


  glutSwapBuffers();
  glFlush();
}



