/*-----------------------------------DEK_READER-----------------*/

#include <stdio.h>    
#include <stdlib.h>
#include <string.h> 
#include <math.h>    
#include "global.h"



int read_dek(int *type,double **par,int **in_u,int **in_nr,
               double **out_n,double **deriv_o)
{
const int a=0; /*-----------------ANALYSE-PRINTS with a=1!!!!!*/
FILE *position;
char line[201];
char *rest;
char string1[80];
char string2[80];

int k_unit;  /*laufende unit des dek's */
int unit_nr,type_nr,par_nr,input_nr,deriv_nr,k;

if ((position=fopen("sim.dek","r"))==NULL)
   {
   printf(" no 'sim.dek'  !! \n\n");
   return -1;
   }
for (k_unit=1;k_unit<=UNIT_MAX;k_unit++) /*--exit if END-----*/
  {
  /*--------------------------UNIT_READ--------------------------*/

    /*--------------- while string1 != "UNIT" && != "END"*/
    while ( (strstr(string1,"UNIT")==NULL) &&
            (strstr(string1,"END")==NULL) )   /* check pattern in string*/
      {
        /*printf("line[0]:%c\n",line[0]);*/
        if (fgets(line,200,position)==NULL)   /* get line*/
          {
            printf("END of FILE when searching 'UNIT' String= %s \n",
                    line);
            string1[1]='E';
            string1[2]='N';
            string1[3]='D';
            break;
          };

                              /*read string1 in line (SPACE=stringEnd)*/
        sscanf(line,"%s",string1);
      };

    if (strstr(string1,"END")!=NULL) break; /*exit if 'END'-----*/

    if (a) printf("pattern-string1=%s \n",string1);

     /* read UNIT-No and TYPE-No */
    sscanf(line,"%s %d %s %d",string1,&unit_nr,string2,&type_nr);

    if ( (unit_nr>=UNIT_MAX) || (unit_nr<0) )
      { printf("unit_nr:%d\n",unit_nr);exit (-1); }

    if (strstr(string1,"TYPE")!=NULL)               /*(string1 != "TYPE")*/
      {  printf(" Fehler bei TYPE-String lesen \n"); };
      /* unit_nr ist tatsaechlich die nr des deks , nicht k_unit!!!*/
    type[unit_nr]=type_nr;

    if (unit_nr!=k_unit) printf("UNIT_Numbers has spaces: UNIT %d\n",
                                unit_nr);
    if (a) printf(" die UNIT %d ist TYPE %d \n",unit_nr,type_nr);

    /*------------------------------PARAMETER_READ-----------------*/
    if (fgets(line,200,position)==NULL)
      {
        printf("lineRead exit when reading PARAMETERS %s \n",line);
        /* exit (-1); */
      };
    sscanf(line,"%s",string1);
    if (a) printf("pattern-string1=%s \n",string1);

    while ( (strstr(string1,"PARAMS")==NULL) )  /*Run to "PARAMS"*/
      {
        if (fgets(line,200,position)==NULL) break ;
        sscanf(line,"%s",string1);
      };
     /*read Par_Nr,Pars*/
    sscanf(line,"%s %d",string1,&par_nr);
     /*alle Parameter einlesen*/
    if ( (par_nr>=PAR_MAX) || (par_nr<0) )
      { printf("par_nr:%d  in unit:%d \n",par_nr,unit_nr);exit (-1); }
    k=1;
    while (k<=par_nr)
      {
        if (fgets(line,200,position)==NULL)
          {
            printf(" linenlesen abgebrochen %s \n",line);
          };
        sscanf(line,"%s",string1);
        if (strstr(string1,"*")==NULL)
          {
            par[unit_nr][k]=strtod(string1,&rest);
            if (a) printf("Parameter(%d) von UNIT(%d) =%f aus string1=%s\n",
                           k,unit_nr,par[unit_nr][k],string1);
            k++;
          };
       }; /*end_while*/

  /*------------------------------INPUTS_READ-----------------------*/

    if (fgets(line,200,position)==NULL)
      {
        printf(" EOF linenlesen abgebrochen %s \n",line);
        return (k_unit);
      };
    sscanf(line,"%s",string1);

    /* lese, bis string1="INPUTS" || "UNIT"  */
    while ( (strstr(string1,"INPUTS")==NULL) &&
            (strstr(string1,"UNIT")==NULL) )
      {
        if (fgets(line,200,position)==NULL)
          { printf(" EOF linenlesen abgebrochen %s \n",line);
            return (k_unit);
          };
        sscanf(line,"%s",string1);
      };

    if (a) printf("pattern-string1=%s \n",string1);

    if (strstr(string1,"INPUTS")!=NULL) /*(string1 != "INPUTS"*/
      {                                       /*read inputs__Nr,Inputs*/
        sscanf(line,"%s %d",string1,&input_nr);

        if ( (input_nr>=INPUT_MAX) || (input_nr<0) )
          { printf("input_nr:%d  in unit:%d \n",input_nr,unit_nr);exit (-1); }

        k=1;                                     /*alle Inputs einlesen*/
        while (k<=input_nr)
          {
            /* search input_units, not empty lines */
            while (1)
             {
               if (fgets(line,200,position)==NULL)
                 { printf(" EOF linenlesen abgebrochen %s \n",line);
                   return(k_unit);
                 };
               sscanf(line,"%s %s",string1,string2);
               if ( (( (int) strlen(line)  )>2) &&
                    (strstr(string1,"*")==0) ) break;
             };

            in_u[unit_nr][k]=(int) (strtod(string1,&rest));
            in_nr[unit_nr][k]=(int) (strtod(string2,&rest));
            if ( (strstr(string2,","))!=NULL)
              {
                printf("Komma vor out_nr bei UNIT %d !!!\n",unit_nr);
                exit (-1);
              };

            if (a) printf("INPUT_unit(%d) von UNIT(%d) =%d aus string1=%s\n",
                          k,unit_nr,in_u[unit_nr][k],string1);
            if (a) printf("INPUT_nr(%d) von UNIT(%d) =%d aus string2=%s\n",
                           k,unit_nr,in_nr[unit_nr][k],string2);

             k++;
          };
                  /*-----------read INPUT INITIAL VALUES ---------*/
        k=1;
        while (k<=input_nr)
          {
            /* search input_units, not empty lines */
            while (1)
             {
               if (fgets(line,200,position)==NULL)
                 { printf(" EOF end of line return %s \n",line);
                   return(k_unit);
                 };
               sscanf(line,"%s %s",string1,string2);
               if ( (( (int) strlen(line)  ) > 1 ) &&
                    (strstr(string1,"*")==0) ) break;
             };
            if (in_u[unit_nr][k]==0)  /*shift initials for fixed values */
              {
                out_n  [unit_nr][30+k]
                 =strtod(string1,&rest);
                in_u [unit_nr][k]=unit_nr;
                in_nr[unit_nr][k]=30+k;
                if (a)
                printf("INPUT_INITIAL(%d) of UNIT(%d) =%f from string1=%s\n",
                    k+30,unit_nr,out_n[unit_nr][30+k],string1);
              }
            else
              {
                /*shift initials for some TYPES */
                out_n  [unit_nr][k+30]
                 =strtod(string1,&rest);
                /* reset outs */
                out_n[unit_nr][k]=0;

                if (a)
                printf("INPUT_INITIAL(%d) von UNIT(%d) =%f aus string1=%s\n",
                        k,unit_nr,out_n[unit_nr][k],string1);
              };
            k++;
          }; /*while-end*/


/*-------------------------READ DERIVATIVES---------------------*/
      /*search DERIVATIVES, if INPUTS != 0 */

     if (fgets(line,200,position)==NULL)
      {
        printf(" EOF linenlesen abgebrochen %s \n",line);
        return(k_unit);
      };
    sscanf(line,"%s",string1);

    /* lese, bis string1="DERIVATIVES" || "UNIT"  */
    while ( (strstr(string1,"DERIVATIVES")==NULL) &&
            (strstr(string1,"UNIT")==NULL) )
      {
        if (fgets(line,200,position)==NULL)
          { printf(" EOF linenlesen abgebrochen %s \n",line);
            return(k_unit);
          };
        sscanf(line,"%s",string1);
      };

    if (a) printf("pattern-string1=%s \n",string1);

    if (strstr(string1,"DERIVATIVES")!=NULL) /*(string1 != "DERIVATIVES"*/
      {                                       /*read deriv__Nr*/
        sscanf(line,"%s %d",string1,&deriv_nr);

        if ( (deriv_nr>=DERIV_MAX) || (deriv_nr<0) )
          { printf("deriv_nr:%d  in unit:%d \n",deriv_nr,unit_nr);exit (-1); }

        k=1;                                     /*alle Derivs einlesen*/
        while (k<=deriv_nr)
          {
            /* search derivation-values, not empty lines and comments*/
            while (1)
             {
               if (fgets(line,200,position)==NULL)
                 { printf(" EOF linenlesen abgebrochen %s \n",line);
                   return(k_unit);
                 };
               sscanf(line,"%s %s",string1,string2);
               if ( (( (int) strlen(line)  )>1) &&
                    (strstr(string1,"*")==0) ) break;
             };

            deriv_o[unit_nr][k]=(int) (strtod(string1,&rest));
            if ( (strstr(string2,","))!=NULL)
              {
                printf("Komma in DERIVATIONS bei UNIT %d !!!\n",unit_nr);
                exit (-1);
              };

            if (a) printf("DERIVATIVES_Nr(%d) von UNIT(%d) =%.3e aus string1=%s\n",
                          k,unit_nr,deriv_o[unit_nr][k],string1);

             k++;
          };

       } /*if-end bei vorhandenen DERIVATIVES*/

        /*--------------------------------------end of deriv-search */

      } /*if-end bei vorhandenen "INPUTS" */

    else { printf("UNIT %d hat weder INPUTS noch DERIVATIVES!!! \n",unit_nr); };


  } /*next_lauf_unit*/
fclose(position);
return (k_unit-1); /*rueckgabe der maximalen units des deks*/
}

