# JAHRESDAUERLINIE
# awk -f ../etc/jahresdauerlinie.awk < ./sim_out0.dat  > ./jahresdauerlinie.dat
# ! insert min max value !!!!!!!!!!!!!!!!!!!!
#    do it with 'min_max.awk' and inserted column
#    awk -f ./etc/min_max.awk <./sim_out0.dat
#    sed -e "s/column = 2/column = 3/" min_max.awk >min_max2.awk
#    e.g. max:84.198152   min:-7.636484
# gnuplot \n  plot [0:8760] './jahresdauerlinie.dat' us 1:2 

BEGIN {
        column = 12 
        max = 25.048996    
        min = 0.000000    

		
        wert           = 0
        intervall_step = 100
        intervall      = ( max - min ) / intervall_step
        scale[s]       = 0
	count_line     = 0
      }

{
# in jeder datenzeile raw-data wert vergleichen 
s = 1
for( wert = min; wert <= max; wert = wert + intervall ) 
    if ( $column >= wert )
      { scale[s] = scale[s] + 1
        s ++ 
      }
    else next
}

END { for( s = 1; s <= intervall_step; s ++)
         printf( "%d %s\n", scale[s], s * intervall + min )
    }
   


