unit_order.h created by cfg/config
/*
   this header is generated with config routine: it's used
   to define unit_order and set_init_mp hydraulic order
*/

int priority[MAX_TYPES]={ 
  /* type 0:          AirRad_node */ 10,
  /* type 1:                   RC */ 12,
  /* type 2:            collector */ 2,
  /* type 3:           controller */ 3,
  /* type 4:         controller_x */ 3,
  /* type 5:             deadtime */ 0,
  /* type 6:      deadtime_change */ 0,
  /* type 7:           dek_reader */ 0,
  /* type 8:         diverter_air */ 2,
  /* type 9:       energy_outcome */ 0,
  /* type10:             equation */ 2,
  /* type11:           equation_x */ 2,
  /* type12:             flow_div */ 2,
  /* type13:     fuzzy_controller */ 3,
  /* type14:          gnu_plotter */ 2,
  /* type15:               heater */ 2,
  /* type16:           heater_air */ 2,
  /* type17:        heatexchanger */ 2,
  /* type18:              heating */ 2,
  /* type19:             heatpump */ 3,
  /* type20:              horizon */ 0,
  /* type21:            hydraulic */ 8,
  /* type22:         inc_angl_mod */ 0,
  /* type23:          init_set_mp */ 0,
  /* type24:    init_type_def_str */ 0,
  /* type25:                 load */ 1,
  /* type26:                 main */ 0,
  /* type27:          malloc_call */ 0,
  /* type28:         mass_element */ 12,
  /* type29:                mixer */ 2,
  /* type30:            mixer_air */ 2,
  /* type31:                pipe2 */ 2,
  /* type32:             pipe_air */ 2,
  /* type33:          print_infos */ 0,
  /* type34:              printer */ 2,
  /* type35:                 pump */ 5,
  /* type36:             pump_air */ 5,
  /* type37:        rad_processor */ 0,
  /* type38:              storage */ 2,
  /* type39:       thermodynamics */ 0,
  /* type40:            type_call */ 0,
  /* type41:      unit_order_init */ 0,
  /* type42:                 wall */ 12,
  /* type43:           water_drop */ 2,
  /* type44:              weather */ 1,
  /* type45:                 zone */ 12
};


int hydraulic_type[MAX_TYPES]={ 
  /* type 0:          AirRad_node */ 99,
  /* type 1:                   RC */ 99,
  /* type 2:            collector */ 1,
  /* type 3:           controller */ 99,
  /* type 4:         controller_x */ 99,
  /* type 5:             deadtime */ 0,
  /* type 6:      deadtime_change */ 0,
  /* type 7:           dek_reader */ 0,
  /* type 8:         diverter_air */ 47,
  /* type 9:       energy_outcome */ 0,
  /* type10:             equation */ 99,
  /* type11:           equation_x */ 99,
  /* type12:             flow_div */ 11,
  /* type13:     fuzzy_controller */ 99,
  /* type14:          gnu_plotter */ 99,
  /* type15:               heater */ 1,
  /* type16:           heater_air */ 50,
  /* type17:        heatexchanger */ 10,
  /* type18:              heating */ 1,
  /* type19:             heatpump */ 1,
  /* type20:              horizon */ 0,
  /* type21:            hydraulic */ 99,
  /* type22:         inc_angl_mod */ 0,
  /* type23:          init_set_mp */ 0,
  /* type24:    init_type_def_str */ 0,
  /* type25:                 load */ 99,
  /* type26:                 main */ 0,
  /* type27:          malloc_call */ 0,
  /* type28:         mass_element */ 99,
  /* type29:                mixer */ 13,
  /* type30:            mixer_air */ 48,
  /* type31:                pipe2 */ 1,
  /* type32:             pipe_air */ 1,
  /* type33:          print_infos */ 0,
  /* type34:              printer */ 99,
  /* type35:                 pump */ 1,
  /* type36:             pump_air */ 49,
  /* type37:        rad_processor */ 0,
  /* type38:              storage */ 4,
  /* type39:       thermodynamics */ 0,
  /* type40:            type_call */ 0,
  /* type41:      unit_order_init */ 0,
  /* type42:                 wall */ 99,
  /* type43:           water_drop */ 1,
  /* type44:              weather */ 99,
  /* type45:                 zone */ 99
};

