/*unit_order.h created by cfg/config */
/*
   this header is generated with config routine: it's used
   to define unit_order and set_init_mp hydraulic order
*/

int priority[MAX_TYPES]={ 
  /* type 0:                      */ 99,
  /* type 1:            collector */ 6,
  /* type 2:           controller */ 3,
  /* type 3:                 pump */ 5,
  /* type 4:              storage */ 6,
  /* type 5:           water_drop */ 6,
  /* type 6:               heater */ 6,
  /* type 7:                      */ 99, 
  /* type 8:              heating */ 6,
  /* type 9:              weather */ 1,
  /* type10:        heatexchanger */ 6,
  /* type11:             diverter */ 6,
  /* type12:             heatpump */ 3,
  /* type13:                mixer */ 6,
  /* type14:                 load */ 1,
  /* type15:         load_control */ 3,
  /* type16:                      */ 99, 
  /* type17:                      */ 99, 
  /* type18:                      */ 99, 
  /* type19:                      */ 99, 
  /* type20:                 zone */ 12,
  /* type21:                      */ 99, 
  /* type22:                      */ 99, 
  /* type23:                   RC */ 12,
  /* type24:             equation */ 2,
  /* type25:              printer */ 15,
  /* type26:         controller_x */ 3,
  /* type27:           equation_x */ 2,
  /* type28:                 wall */ 12,
  /* type29:          AirRad_node */ 10,
  /* type30:                      */ 99, 
  /* type31:                pipe2 */ 6,
  /* type32:             pipe_air */ 6,
  /* type33:         mass_element */ 12,
  /* type34:                      */ 99, 
  /* type35:            hydraulic */ 4,
  /* type36:                valve */ 6,
  /* type37:                      */ 99, 
  /* type38:            HydResist */ 6,
  /* type39:                      */ 99, 
  /* type40:                      */ 99, 
  /* type41:                      */ 99, 
  /* type42:                      */ 99, 
  /* type43:                      */ 99, 
  /* type44:                      */ 99, 
  /* type45:                      */ 99, 
  /* type46:                      */ 99, 
  /* type47:         diverter_air */ 6,
  /* type48:            mixer_air */ 6,
  /* type49:             pump_air */ 5,
  /* type50:           heater_air */ 6,
  /* type51:                      */ 99, 
  /* type52:                      */ 99, 
  /* type53:                      */ 99, 
  /* type54:                      */ 99, 
  /* type55:                      */ 99, 
  /* type56:                      */ 99, 
  /* type57:          rotation_ex */ 6,
  /* type58:                      */ 99, 
  /* type59:                      */ 99, 
  /* type60:    heatexchanger_air */ 6,
  /* type61:              shading */ 13,
  /* type62:                      */ 99, 
  /* type63:                      */ 99, 
  /* type64:                      */ 99, 
  /* type65:          gnu_plotter */ 12,
};


int hydraulic_type[MAX_TYPES]={ 
  /* type 0:                      */ 99,
  /* type 1:            collector */ 1,
  /* type 2:           controller */ 99,
  /* type 3:                 pump */ 3,
  /* type 4:              storage */ 4,
  /* type 5:           water_drop */ 1,
  /* type 6:               heater */ 1,
  /* type 7:                      */ 99,
  /* type 8:              heating */ 1,
  /* type 9:              weather */ 99,
  /* type10:        heatexchanger */ 10,
  /* type11:             diverter */ 11,
  /* type12:             heatpump */ 1,
  /* type13:                mixer */ 13,
  /* type14:                 load */ 99,
  /* type15:         load_control */ 99,
  /* type16:                      */ 99,
  /* type17:                      */ 99,
  /* type18:                      */ 99,
  /* type19:                      */ 99,
  /* type20:                 zone */ 99,
  /* type21:                      */ 99,
  /* type22:                      */ 99,
  /* type23:                   RC */ 99,
  /* type24:             equation */ 99,
  /* type25:              printer */ 99,
  /* type26:         controller_x */ 99,
  /* type27:           equation_x */ 99,
  /* type28:                 wall */ 99,
  /* type29:          AirRad_node */ 99,
  /* type30:                      */ 99,
  /* type31:                pipe2 */ 1,
  /* type32:             pipe_air */ 32,
  /* type33:         mass_element */ 99,
  /* type34:                      */ 99,
  /* type35:            hydraulic */ 99,
  /* type36:                valve */ 1,
  /* type37:                      */ 99,
  /* type38:            HydResist */ 1,
  /* type39:                      */ 99,
  /* type40:                      */ 99,
  /* type41:                      */ 99,
  /* type42:                      */ 99,
  /* type43:                      */ 99,
  /* type44:                      */ 99,
  /* type45:                      */ 99,
  /* type46:                      */ 99,
  /* type47:         diverter_air */ 47,
  /* type48:            mixer_air */ 48,
  /* type49:             pump_air */ 49,
  /* type50:           heater_air */ 50,
  /* type51:                      */ 99,
  /* type52:                      */ 99,
  /* type53:                      */ 99,
  /* type54:                      */ 99,
  /* type55:                      */ 99,
  /* type56:                      */ 99,
  /* type57:          rotation_ex */ 57,
  /* type58:                      */ 99,
  /* type59:                      */ 99,
  /* type60:    heatexchanger_air */ 50,
  /* type61:              shading */ 99,
  /* type62:                      */ 99,
  /* type63:                      */ 99,
  /* type64:                      */ 99,
  /* type65:          gnu_plotter */ 99,
};
